#!/usr/bin/env python
# was using /sw/bin/python2.7 -tt
# filter.py
# this file is the driver for the python analysis script

# system includes
import sys
import os
import getopt
import glob
from math import *
from numpy import *
import random

from sg import SG

def main(argv):

  dfwidth=5
  dfdegree=3
  dfo=1

  x = arange(-dfwidth,dfwidth+1,dtype=int)
  monom = lambda x, deg : pow(x,deg)

  print(x)

  A = zeros((2*dfwidth+1, dfdegree+1), float)
  for i in range(2*dfwidth+1):
    for j in range(dfdegree+1):
      A[i,j] = monom(x[i], j)

  print(A)

  ATA = dot(A.transpose(),A)
  print(ATA)

  rhs = zeros((dfdegree+1,), float)
  rhs[dfo] = (-1)**dfo
  print(rhs)

  wvec = linalg.solve(ATA, rhs)
  print(wvec)

  # calculate filter-coefficients
  coeff = dot(A, wvec)
  print(coeff)

  print("length of coeffs = %f\n" % len(coeff))

  print("sum of coeffs = %f\n" % sum(coeff))

  sgx = SG(dfwidth,dfdegree,dfo)
  sgy = SG(dfwidth,dfdegree,dfo)

  N = (dfwidth-1)/2

  # for real-time testing
  for i in range(100):
    # feed the SG filter the same number (whatever it is) for a long time
    dxdt = sgx.sgf(1337)
#   print "len = %d" % len(dxdt)
    # and we should be seeing 0 after while (as in 0 velocity)
    print(dxdt)
#   print "N = %f\n" % N
#   print "len[N:-N] = %d" % len(dxdt[N:-N])
#   print dxdt[N:-N]

if __name__ == "__main__":
 
  main(sys.argv[1:])
