#!/usr/bin/env python

import sys, os, math

#subj,cond,stim,AOI,duration,order
class Header:
  subj         = 0
  cond         = 1
  stim         = 2
  AOI          = 3
  duration     = 4
  order        = 5

def catCSVFile(infile,df,ct):
  try:
    f = open(infile,'r')
  except IOError:
    print("Can't open file: " + infile)
    return

  # read lines, throwing away first one (header)
# linelist = f.readlines()
# linelist = f.read().split('\r')
  linelist = f.read().splitlines()
  linelist = linelist[1:]

  for line in linelist:
    entry = line.split(',')

    # init subj
    subj      = entry[Header.subj]
    cond      = entry[Header.cond]
    stim      = entry[Header.stim]
    AOI       = entry[Header.AOI]
    duration  = entry[Header.duration]

    # dump out line excluding "trial"
    str = "%s,%s,%s,%s,%s,%s" % (subj,cond,stim,AOI,duration,ct)
    print(str, file=df)
    ct += 1

  return ct

###############################################################################

# clear out output file
df = open("aois.csv",'w')
print("subj,cond,stim,AOI,duration,order", file=df)

dir = './data/'

# find all files in dir with .csv extension
lst = [a for a in os.listdir(dir) if a.endswith('-aois.csv')]

lineno = 1

for item in lst:

  file = dir + item
  print('Processing ', file)

  # cat csv files into one
  lineno = catCSVFile(file,df,lineno)

df.close()
